unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Math;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    Edit2: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit3: TEdit;
    GroupBox2: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Edit6: TEdit;
    GroupBox3: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Edit7: TEdit;
    Edit8: TEdit;
    GroupBox4: TGroupBox;
    Edit9: TEdit;
    Label9: TLabel;
    Label10: TLabel;
    Button1: TButton;
    Button2: TButton;
    GroupBox5: TGroupBox;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Button3: TButton;
    CheckBox1: TCheckBox;
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button2Click(Sender: TObject);
begin
close; //Beenden
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
Edit1.Text:='';
Edit2.Text:='';      //Lschen der Koordinaten
Edit3.Text:='';
Edit4.Text:='';
Edit5.Text:='';
Edit6.Text:='';
Label13.Caption:='';
Label14.Caption:='';
end;

procedure TForm1.Button1Click(Sender: TObject);
var alpha,delta,m,n,jahre,j,neualpha,neudelta,h1,h2,h3:extended;
    i:integer;
begin                 //Berechen

if edit1.text=''
then
edit1.text:='0';

if edit2.text=''
then
edit2.text:='0';

if edit3.text=''
then
edit3.text:='0';

if edit4.text=''
then
edit4.text:='0';

if edit5.text=''
then
edit5.text:='0';

if edit6.text=''
then
edit6.text:='0';

if strtofloat(edit1.Text)<0
then
alpha:=strtofloat(edit1.text)*3600-strtofloat(edit2.text)*60-strtofloat(edit3.Text)
else
alpha:=strtofloat(edit1.text)*3600+strtofloat(edit2.text)*60+strtofloat(edit3.Text);

if strtofloat(edit4.Text)<0
then
delta:=strtofloat(edit4.text)*3600-strtofloat(edit5.text)*60-strtofloat(edit6.Text)
else
delta:=strtofloat(edit4.text)*3600+strtofloat(edit5.text)*60+strtofloat(edit6.Text);

alpha:=alpha/206265/24*360;             //Ausgangswerte
delta:=delta/206265;


if checkbox1.checked=false
then
begin
m:=strtofloat(edit7.Text)/206265;       //Konstanten
n:=strtofloat(edit8.Text)/206265;
end
else
begin
m:=46.085/206265;
n:=20.047/206265;
end;

jahre:=strtofloat(edit9.text);

if jahre<0
then                            //Fortrechnen
begin

for i:=1 to trunc(-jahre) do
begin
neualpha:=m+n*tan(delta)*sin(alpha);
neudelta:=n*cos(alpha);
alpha:=alpha-neualpha;
delta:=delta-neudelta;
end;

neualpha:=m+n*tan(delta)*sin(alpha);
neudelta:=n*cos(alpha);
j:=(jahre-trunc(jahre));
alpha:=alpha+j*neualpha;
delta:=delta+j*neudelta;

end
else
begin

for i:=1 to trunc(jahre) do
begin
neualpha:=m+n*tan(delta)*sin(alpha);
neudelta:=n*cos(alpha);
alpha:=alpha+neualpha;
delta:=delta+neudelta;
end;

neualpha:=m+n*tan(delta)*sin(alpha);
neudelta:=n*cos(alpha);
j:=(jahre-trunc(jahre));
alpha:=alpha+j*neualpha;
delta:=delta+j*neudelta;

end;


alpha:=alpha*206265*24/360;             //Rckausgabe
delta:=delta*206265;


if alpha<0
then
begin
h1:=trunc(alpha/(3600));
h2:=trunc((-alpha/60+h1*60));
h3:=trunc(-alpha+h1*3600-h2*60);
label13.caption:=floattostr(h1)+'h '+floattostr(h2)+' '+floattostr(h3)+'"';
end
else
begin
h1:=trunc(alpha/(3600));
h2:=trunc(alpha/60-h1*60);
h3:=trunc(alpha-h1*3600-h2*60);
label13.caption:=floattostr(h1)+'h '+floattostr(h2)+' '+floattostr(h3)+'"';
end;

if delta<0
then
begin
h1:=trunc(delta/3600);
h2:=trunc(-delta/60+h1*60);
h3:=trunc(-delta+h1*3600-h2*60);
label14.caption:=floattostr(h1)+' '+floattostr(h2)+' '+floattostr(h3)+'"';
end
else
begin
h1:=trunc(delta/3600);
h2:=trunc(delta/60-h1*60);
h3:=trunc(delta-h1*3600-h2*60);
label14.caption:=floattostr(h1)+' '+floattostr(h2)+' '+floattostr(h3)+'"';
end;

end;

end.
